<?xml version="1.0" encoding="utf-8"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/officity/shared/environment/environment.definitions.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
	<!-- EDITOR/APPLICATION -->
	<xsl:template match="OFFICITY:ENVIRONMENT" mode="element-editor">
		<xsl:text>officity</xsl:text>
	</xsl:template>
	<xsl:template match="OFFICITY:ENVIRONMENT" mode="element-application">
		<xsl:text>factory</xsl:text>
	</xsl:template>
	<xsl:template match="OFFICITY:ENVIRONMENT" mode="element-application-editor">
		<xsl:text>officity</xsl:text>
	</xsl:template>
	
    <!-- LABEL(s) -->
	<xsl:template match="OFFICITY:ENVIRONMENT[INFO/PUBLISHED=1]" mode="element-label">
        <xsl:value-of select="//LIST[@name='EnvironmentType']/ITEM[@value=current()/INFO/TYPE]/@label"/>
	</xsl:template>
	
	<xsl:template match="OFFICITY:ENVIRONMENT[INFO/PUBLISHED=0]" mode="element-label">
        <span style="color:#666666; font-style:italic;">
	        <xsl:value-of select="//LIST[@name='EnvironmentType']/ITEM[@value=current()/INFO/TYPE]/@label"/>
        </span>
	</xsl:template>

	<!-- ICON(s) -->
	<xsl:template match="OFFICITY:ENVIRONMENT[INFO/TYPE='production']" mode="element-icon">
		<xsl:text>../system/images/icons/environment/prod.png</xsl:text>
	</xsl:template>
	<xsl:template match="OFFICITY:ENVIRONMENT[INFO/TYPE='beta']" mode="element-icon">
		<xsl:text>../system/images/icons/environment/beta.png</xsl:text>
	</xsl:template>
	<xsl:template match="OFFICITY:ENVIRONMENT[INFO/TYPE='development']" mode="element-icon">
		<xsl:text>../system/images/icons/environment/dev.png</xsl:text>
	</xsl:template>
	<xsl:template match="OFFICITY:ENVIRONMENT[INFO/TYPE='versions']" mode="element-icon">
		<xsl:text>../system/images/icons/environment/ver.png</xsl:text>
	</xsl:template>

	<!-- INFO LABEL(s) -->
	<xsl:template match="OFFICITY:ENVIRONMENT" mode="element-info">
        <xsl:value-of select="INFO/FOLDER"/>
	</xsl:template>

	<!-- NAVIGATION ITEM(s) -->
	
	<!-- TITLE(s) -->
	<xsl:template match="OFFICITY:ENVIRONMENT" mode="element-title">
        <xsl:variable name="module">
    		<xsl:call-template name="translate-namespace-name">
        		<xsl:with-param name="name" select="name(.)"/>
        	</xsl:call-template>
        </xsl:variable>
        
		<h2 class="{$module}-{INFO/TYPE}">
			<xsl:apply-templates select="." mode="element-label"/>
		</h2>
	</xsl:template>
	
	<!-- SCRIPTS -->
	<!--xsl:template match="OFFICITY:ENVIRONMENT" mode="element-script-detail">
		<xsl:text>environments/Index</xsl:text>
	</xsl:template-->
</xsl:stylesheet>