<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/system/tools/element/RawLink.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
    <xsl:import href="include.no-editors.xsl"/>    
    <xsl:output encoding="UTF-8" method="xml" indent="no"/>
    <xsl:strip-space elements="*"/>

	<!-- parameters -->
    <xsl:param name="module" select="/RESPONSE/URL/module"/>
    <xsl:param name="searchText" select="/RESPONSE/URL/quicksearch-text" />
    <xsl:param name="originID" select="/RESPONSE/URL/originID"/>
    <xsl:param name="dependency" select="/RESPONSE/URL/dependency"/>
    <xsl:param name="targetModule" select="/RESPONSE/URL/targetModule"/>
    <xsl:param name="depsList" select="'depsList'"/>
    
	<xsl:template match="/RESPONSE">
		<xsl:call-template name="panel-link">
			<xsl:with-param name="list" select="/RESPONSE/RESULTS[@name='list']"/>
	        <xsl:with-param name="addNew" select="true()"/>
	        <xsl:with-param name="pagingStyle" select="'pager'"/>
	        <xsl:with-param name="searchText">
	        	<xsl:text>Link to </xsl:text>
	        	<xsl:value-of select="$targetModule" />
	        	<xsl:text> elements...</xsl:text>
	        </xsl:with-param>
		</xsl:call-template>
    </xsl:template>
    
    <xsl:template name="panel-title">
    	<xsl:value-of select="$dependency" />
        <xsl:text> (</xsl:text>
        <xsl:value-of select="$module" />
        <xsl:text> =&gt; </xsl:text>
        <xsl:value-of select="$targetModule" />
        <xsl:text>)</xsl:text>
    </xsl:template>
    
	<xsl:template match="*" mode="element-script-detail">
		<xsl:text>../../system/tools/element/RawDetails</xsl:text>
	</xsl:template>    
</xsl:stylesheet>
