<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/system/tools/filter/DisplayList.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
    <xsl:import href="include.xsl"/>
    <xsl:output encoding="UTF-8" method="xml" indent="no"/>
    <xsl:strip-space elements="*"/>
    
    <xsl:param name="list" select="/RESPONSE/RESULTS[@name='display-configs']"/>   
    
	<xsl:template match="/RESPONSE">
    	<xsl:call-template name="panel-navigation" />
    </xsl:template>

    <xsl:template name="panel-body-navigation">
            <xsl:choose>
                <xsl:when test="count($list/*)&gt;0">
                    <xsl:for-each select="$list/OFFICITY:FILTER">
                        <xsl:sort select="INFO/OWNERID"/>
                        <xsl:sort select="INFO/CREATIONDATE" order="descending"/>
                        <xsl:apply-templates select="." mode="filterdisplay-staticitem"/>
                    </xsl:for-each>                    
                </xsl:when>
                <xsl:otherwise>
					<div class="no-result">No display configurations found</div>
                </xsl:otherwise>
              </xsl:choose>
	</xsl:template>
	
    <xsl:template name="panel-js-navigation">
        <xsl:call-template name="panel-bind-delete-event" />
	</xsl:template>
</xsl:stylesheet>
