<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/system/tools/search/newsearch-resources-cmds-templates.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output encoding="UTF-8" method="xml" indent="no" omit-xml-declaration="yes"/>
	<xsl:strip-space elements="*"/>
	
	<xsl:param name="search-config" select="/RESPONSE/RESULTS[@name='search-config']/CONFIGXML"/>
	<xsl:param name="target-field" select="/RESPONSE/RESULTS[@name='field']/FIELD"/>

	<xsl:template match="/RESPONSE">
		<xsl:choose>
			<xsl:when test="$target-field">
	        	<xsl:apply-templates select="$target-field" />
	        </xsl:when>
	        <xsl:otherwise>
	        	<!-- see load-search-template.php -->
	        	<xsl:apply-templates select="$search-config/CATEGORIES/CATEGORY[@name=/RESPONSE/URL/category]"/>
	        </xsl:otherwise>
        </xsl:choose>
	</xsl:template>

	<!-- FIELDS -->
	<xsl:template match="FIELD[(INFO/TYPE='elementsList') and (INFO/TARGETMODULE/text()) and (INFO/TARGETFIELD/text())]">
		<xsl:variable name="up-module" select="translate(INFO/TARGETMODULE,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
		<xsl:variable name="up-field" select="translate(INFO/TARGETFIELD,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>

        <SEARCH name="{INFO/TARGETMODULE}" refresh="daily">
            <xsl:element name="{$up-module}"/>
            <RETURN>
                <INFO>
                    <xsl:element name="{$up-field}"/>
                </INFO>
            </RETURN>
        </SEARCH>
	</xsl:template>
	
	<xsl:template match="FIELD[INFO/TYPE='list']">
        <GET refresh="daily" name="{INFO/LISTNAME}">
            <LIST name="{INFO/LISTNAME}"/>
        </GET>
	</xsl:template>

	<xsl:template match="FIELD[INFO/TYPE='systemList' and INFO/LISTNAME='Countries']">
        <GET name="Countries" refresh="monthly">
            <COUNTRIES/>
        </GET>
	</xsl:template>

	<xsl:template match="FIELD[INFO/TYPE='systemList' and INFO/LISTNAME='Languages']">
        <GET name="Languages" refresh="monthly">
            <LANGUAGES profile="SmallList"/>
        </GET>
	</xsl:template>

	<xsl:template match="FIELD"/>
	
	<!-- CATEGORIES -->
	<xsl:template match="CATEGORY[@name]">
		<GET refresh="daily" name="{@name}">
			<CATEGORY name="{@name}" />				
			<RETURN totalElements="false" depth="all"/>
		</GET>
	</xsl:template>
	
	<xsl:template match="CATEGORY[@path]">
		<GET refresh="daily" name="{@path}">
			<CATEGORIES path="{@path}" />				
			<RETURN totalElements="false" depth="all"/>
		</GET>
	</xsl:template>
</xsl:stylesheet>