<?php
/*
Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/sushee-source/sushee/private/authorizeWebaccount.inc.php` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.
*/
require_once(dirname(__FILE__).'/../common/nqlOperation.class.php');
require_once(dirname(__FILE__).'/../common/webaccount/webaccount.class.php');

class Sushee_authorizeWebAccount extends NQLOperation{
	
	function parse(){
		
		$ID = $this->firstNode->valueOf('@ID');
		if(!$ID){
			$this->setError('No ID given in the request');
			return false;
		}
		$account = new Sushee_WebAccount($ID);
		if(!$account->exists()){
			$this->setError('Account(ID:`'.$ID.'`) doesn\'t exist');
			return false;
		}
		$this->setElementID($ID);
		
		return true;
	}
	
	function operate(){
		$account = new Sushee_WebAccount($this->getElementID());
		
		$res = $account->authorize();
		if(!$res){
			$this->setError($account->getError());
		}else{
			$this->setSuccess('Web API authorized');
		}
		
		return $res;
	}
	
}


?>