<?xml version="1.0" encoding="utf-8"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/sushee-source/sushee/templates/categories_to_xlf.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="xml" indent="no" encoding="utf-8" omit-xml-declaration="yes"/>
	
	<xsl:param name="source-language" select="/RESPONSE/XLIFF-CONFIG/source-language/@ID"/>
	<xsl:param name="source-language-iso1" select="/RESPONSE/XLIFF-CONFIG/source-language/@ISO1"/>
	<xsl:param name="destination-language" select="/RESPONSE/XLIFF-CONFIG/destination-language/@ID"/>
	<xsl:param name="destination-language-iso1" select="/RESPONSE/XLIFF-CONFIG/destination-language/@ISO1"/>
	
	<xsl:template match="/">
		<xsl:apply-templates select="//CATEGORY"/>
	</xsl:template>
	
	<xsl:template match="CATEGORY">
		<trans-unit id="category{@ID}">
			<source xml:lang="{$source-language-iso1}"><xsl:value-of select="LABEL[@languageID=$source-language]"/></source>
			<target state="new" xml:lang="{$destination-language-iso1}"><xsl:value-of select="LABEL[@languageID=$source-language]"/></target>
		</trans-unit>
	</xsl:template>
</xsl:stylesheet>